import { ClientApplication } from '../../../client/types';
import { ActionSet } from '../../ActionSet';
export declare enum Action {
    LOADING = "LOADING",
    LOADED = "LOADED"
}
export interface Options {
    readonly id?: string;
}
export interface ModalContentPayload extends Options {
    loading?: boolean;
}
/**
 * A set of Actions for updating the modal component
 * @public
 */
export declare class ModalContent extends ActionSet {
    constructor(app: ClientApplication, options?: Options);
    loaded(): void;
    loading(): void;
    /**
     * @private
     */
    private dispatch;
    /**
     * @internal
     */
    private dispatchModalAction;
}
