import { MetaAction, Group } from '../types';
export declare enum Action {
    SKELETON_PAGE_LOAD = "APP::PERFORMANCE::SKELETON_PAGE_LOAD",
    FULL_PAGE_LOAD = "APP::PERFORMANCE::FULL_PAGE_LOAD"
}
export interface ActionBase extends MetaAction {
    readonly group: typeof Group.Performance;
}
export interface SkeletonPageLoadAction extends ActionBase {
    readonly type: typeof Action.SKELETON_PAGE_LOAD;
}
export interface FullPageLoadAction extends ActionBase {
    readonly type: typeof Action.FULL_PAGE_LOAD;
}
export declare function skeletonPageLoad(): SkeletonPageLoadAction;
export declare function fullPageLoad(): FullPageLoadAction;
