import { Action } from '../../actions/ButtonGroup/index.js';
import { composeSchemas, validate, matchesObject, matchesArray, makeOptional } from '../type-validate.js';
import { createActionValidator } from '../utils.js';
import { buttonSchema, buttonSchemaWithId } from './button.js';

const buttonGroupSchema = composeSchemas(buttonSchema, matchesObject({
    buttons: matchesArray(makeOptional(buttonSchemaWithId)),
}));
function validateProps(props) {
    return validate(props, buttonGroupSchema);
}
function validateAction(action) {
    const validator = createActionValidator(Action, buttonGroupSchema, true, true);
    return validate(action, validator);
}

export { Action, buttonGroupSchema, validateAction, validateProps };
