import { makeOptional, validate, matchesObject, matchesBoolean } from '../type-validate.js';
import { Action } from '../../actions/ContextualSaveBar/index.js';
import { createActionValidator } from '../utils.js';

const contextSaveBarSchema = makeOptional(matchesObject({
    fullWidth: makeOptional(matchesBoolean()),
    discardAction: makeOptional(matchesObject({
        disabled: makeOptional(matchesBoolean()),
        discardConfirmationModal: makeOptional(matchesBoolean()),
    })),
    saveAction: makeOptional(matchesObject({
        disabled: makeOptional(matchesBoolean()),
    })),
    leaveConfirmationDisable: makeOptional(matchesBoolean()),
}));
function validateProps(props) {
    return validate(props, contextSaveBarSchema);
}
function validateAction(action) {
    const validator = createActionValidator(Action, contextSaveBarSchema);
    return validate(action, validator);
}

export { Action, contextSaveBarSchema, validateAction, validateProps };
