import { Action } from '../../actions/FeedbackModal/index.js';
import { matchesObject, validate, matchesPositiveInteger } from '../type-validate.js';
import { createActionValidator } from '../utils.js';

const feedbackModalSchema = matchesObject({
    formId: matchesPositiveInteger(),
});
function validateProps(props) {
    return validate(props, feedbackModalSchema);
}
function validateAction(action) {
    switch (action.type) {
        case Action.OPEN:
            return validate(action, createActionValidator(Action, feedbackModalSchema, true));
        case Action.CLOSE:
        default:
            return validate(action, createActionValidator(Action));
    }
}

export { Action, feedbackModalSchema, validateAction, validateProps };
