"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = exports.buttonGroupSchema = void 0;
exports.validateProps = validateProps;
exports.validateAction = validateAction;
var ButtonGroup_1 = require("../../actions/ButtonGroup");
Object.defineProperty(exports, "Action", { enumerable: true, get: function () { return ButtonGroup_1.Action; } });
var type_validate_1 = require("../type-validate");
var utils_1 = require("../utils");
var button_1 = require("./button");
exports.buttonGroupSchema = (0, type_validate_1.composeSchemas)(button_1.buttonSchema, (0, type_validate_1.matchesObject)({
    buttons: (0, type_validate_1.matchesArray)((0, type_validate_1.makeOptional)(button_1.buttonSchemaWithId)),
}));
function validateProps(props) {
    return (0, type_validate_1.validate)(props, exports.buttonGroupSchema);
}
function validateAction(action) {
    var validator = (0, utils_1.createActionValidator)(ButtonGroup_1.Action, exports.buttonGroupSchema, true, true);
    return (0, type_validate_1.validate)(action, validator);
}
