"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = exports.feedbackModalSchema = void 0;
exports.validateProps = validateProps;
exports.validateAction = validateAction;
var FeedbackModal_1 = require("../../actions/FeedbackModal");
Object.defineProperty(exports, "Action", { enumerable: true, get: function () { return FeedbackModal_1.Action; } });
var type_validate_1 = require("../type-validate");
var utils_1 = require("../utils");
exports.feedbackModalSchema = (0, type_validate_1.matchesObject)({
    formId: (0, type_validate_1.matchesPositiveInteger)(),
});
function validateProps(props) {
    return (0, type_validate_1.validate)(props, exports.feedbackModalSchema);
}
function validateAction(action) {
    switch (action.type) {
        case FeedbackModal_1.Action.OPEN:
            return (0, type_validate_1.validate)(action, (0, utils_1.createActionValidator)(FeedbackModal_1.Action, exports.feedbackModalSchema, true));
        case FeedbackModal_1.Action.CLOSE:
        default:
            return (0, type_validate_1.validate)(action, (0, utils_1.createActionValidator)(FeedbackModal_1.Action));
    }
}
