"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.Action = exports.titleBarSchema = void 0;
exports.validateProps = validateProps;
exports.validateAction = validateAction;
var TitleBar_1 = require("../../actions/TitleBar");
Object.defineProperty(exports, "Action", { enumerable: true, get: function () { return TitleBar_1.Action; } });
var Button_1 = require("../../actions/Button");
var ButtonGroup_1 = require("../../actions/ButtonGroup");
var type_validate_1 = require("../type-validate");
var utils_1 = require("../utils");
var button_1 = require("./button");
var buttonGroup_1 = require("./buttonGroup");
var buttonSchemaWithId = (0, type_validate_1.composeSchemas)(button_1.buttonSchema, (0, type_validate_1.matchesObject)({
    id: (0, type_validate_1.matchesString)(),
}));
exports.titleBarSchema = (0, type_validate_1.matchesObject)({
    breadcrumbs: (0, type_validate_1.makeOptional)(button_1.buttonSchema),
    title: (0, type_validate_1.makeOptional)((0, type_validate_1.matchesString)()),
    buttons: (0, type_validate_1.makeOptional)((0, type_validate_1.matchesObject)({
        primary: (0, type_validate_1.makeOptional)(buttonSchemaWithId),
        secondary: (0, type_validate_1.makeOptional)((0, type_validate_1.matchesArray)((0, type_validate_1.composeSchemas)(buttonSchemaWithId, (0, type_validate_1.matchesObject)({
            buttons: (0, type_validate_1.makeOptional)((0, type_validate_1.matchesArray)(buttonSchemaWithId)),
        })))),
    })),
});
function validateProps(props) {
    return (0, type_validate_1.validate)(props, exports.titleBarSchema);
}
function validateAction(action) {
    switch (action.type) {
        default:
        case TitleBar_1.Action.UPDATE:
            return (0, type_validate_1.validate)(action, (0, utils_1.createActionValidator)(TitleBar_1.Action, exports.titleBarSchema, true, false));
        case TitleBar_1.Action.BUTTON_CLICK:
        case TitleBar_1.Action.BREADCRUMBS_CLICK:
            return (0, button_1.validateAction)(__assign(__assign({}, action), { type: Button_1.Action.CLICK }));
        case TitleBar_1.Action.BUTTON_UPDATE:
        case TitleBar_1.Action.BREADCRUMBS_UPDATE:
            return (0, button_1.validateAction)(__assign(__assign({}, action), { type: Button_1.Action.UPDATE }));
        case TitleBar_1.Action.BUTTON_GROUP_UPDATE:
            return (0, buttonGroup_1.validateAction)(__assign(__assign({}, action), { type: ButtonGroup_1.Action.UPDATE }));
    }
}
